%{
#include <stdlib.h>
#include "symtbl.h"

#define YYSTYPE char * 
int i;
/* 	La ridefinizione di YYSTYPE puo causare problemi se si
	fa uso dell'opzione "-d" di bison per generare un file 
	include da usare con lex, in tale file verrebbe comunque definito
	YYSTYPE	come int.
	yacc e byacc non includono YYSTYPE tra i simboli definiti in y.tab.c
*/
	
struct symbol_tbl tabella_simboli;
p_symbol_tbl p_tabella=&tabella_simboli;

%}

%token num id relop addop mulop CONST

%%
pgm		: const_decls s_expr	/*programma*/
		;

const_decls	: CONST cds ';'		
		| 	
		/*| error ';' { yyerror("Errore nella sezione di dichiarazione costanti\n");yyerrok;}*/
		; 
cds		: id relop num 		{insert(p_tabella,$1,$3);	} 	 	
		| id relop num ',' cds	{ insert(p_tabella,$1,$3); }	 		
		;

s_expr		: s_expr addop term		{ printf("%s\n",$2);}	
		| term			
		;
		

term		: term mulop factor		{ printf("%s\n",$2);}
		| factor		
		;

factor		: num				{printf("PUSH %s\n",$1);}	
		| '(' s_expr ')'		{ $$=$2;}
		| id				{ i=find(p_tabella,$1);
						  if(i<p_tabella->next_free_sym)			
							printf("PUSH %s\n",p_tabella->symbol[find(p_tabella,$1)].s_val);
						else {	printf("ERRORE: La costante %s non e' stata dichiarata\n",$1);
							YYABORT;	}
						}
		;	
%%

#include "lex.yy.c"

int yyerror(char *s) 
{
printf("%s\n",s);
}

int main()
{
p_tabella->next_free_sym=0;

yyparse();
}

